unit urllabel;
{
URLLabel Ver. 1.1.0.0
for Delphi 3 (It should work with D2 but I haven't tested it):
Developed by Filippo Passeggieri following some advices in
the UDDF site.
Initially, I thought to sell URLLabel at 250USD, but on second thought
I decided, being my first component, it had to be FREEWARE. :-)
If you have suggestions, bug reports please E-Mail me at:
   Passeggieri@Geocities.com

ATTENTION!!!!!
Use URLLabel component at your own risk!!! I decline any responsibility.
----------------------------------------------------------------------------
History:
06/11/97 - Corrected minor bugs.
04/11/97 - Added support to choose different colors if TURLLabel pressed or not
           (properties SetColStd, SetColPre);
02/11/97 - Added support for Mail (property HTTPorMail).
31/10/97 - First release.
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,ShellApi;

type
  THTTPorMAIL = (hmHTTP, hmMAIL);

  TURLLabel = class(TCustomLabel)
  private
    { Private declarations }
    FHTTPorMail: THTTPorMail;
    FColStd : TColor;
    FColPre : TColor;
    procedure SetHTTPorMail(value : THTTPorMail);
    procedure SetColStd(Value: TColor);
    procedure SetColPre(Value: TColor);
  protected
    { Protected declarations }
    procedure Click; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
              X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
              X, Y: Integer); override;
  public
    { Public declarations }
    constructor Create( AOwner : TComponent); override;
    procedure OpenObject(sObjectPath : PChar);
  published
    { Published declarations }
    property HTTPorMail : THTTPorMAIL
       read FHTTPorMail
       write SetHTTPorMail
       default hmHTTP;
    property URLColStd: TColor
       read FColStd
       write SetColStd
       default clBlue;
    property URLColPre: TColor
       read FColPre
       write SetColPre
       default clRed;
    property Caption;
    property WordWrap;
    property Align;
    property Font;
    property AutoSize;
    property Alignment;
    property ParentFont;
    property Transparent;
    property Hint;
    property ShowHint;
  end;

procedure Register;

implementation

const
   HTTP = 'http:\\';
   MAIL = 'mailto:';

constructor TURLLabel.Create( AOwner : TComponent);
begin
   inherited Create(AOwner);

   cursor := crHandPoint;
   FColStd := clBlue;
   FColPre := clRed;
   font.color := FColStd;
   font.Style := [fsUnderline];
end;


procedure TURLLabel.SetHTTPorMail;
begin
   if FHTTPorMail <> Value then
   begin
      FHTTPorMail := Value;
      Invalidate;
   end;
end;

procedure TURLLabel.SetColStd;
begin
   if FColStd <> Value then
   begin
     FColStd := Value;
     font.color := FColStd;
     Invalidate;
   end;
end;

procedure TURLLabel.SetColPre;
begin
   if FColPre <> Value then
   begin
     FColPre := Value;
     Invalidate;
   end;
end;

procedure TURLLabel.OpenObject(sObjectPath : PChar);
begin
   ShellExecute(0, Nil, sObjectPath, Nil, Nil, SW_NORMAL);
end;

procedure TURLLabel.Click;
var
  TempString : array[0..79] of char;
  szApp : string;
begin
   Inherited Click;
   if FHTTPorMail = hmHTTP then
      szApp := HTTP else szApp := MAIL;
   StrPCopy(TempString,szApp+Caption);
   OpenObject(TempString);
end;

procedure TURLLabel.MouseDown(Button: TMouseButton; Shift: TShiftState;
              X, Y: Integer);
begin
   inherited MouseDown(Button,Shift,X,Y);
   if Button = mbLeft then font.color := URLColPre;
end;

procedure TURLLabel.MouseUp(Button: TMouseButton; Shift: TShiftState;
              X, Y: Integer);
begin
   inherited MouseUp(Button,Shift,X,Y);
   font.color := URLColStd;
end;

procedure Register;
begin
  RegisterComponents('Freeware', [ TURLLabel ]);
end;

end.
